"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ix_1 = require("@reactive-js/ix");
const liftImpl = (operator, dispatchOperator) => iterator => {
    const observable = iterator.observable || iterator;
    const dispatcher = iterator.dispatcher || ((req) => iterator.dispatch(req));
    const disposable = iterator.disposable || iterator;
    const liftedObservable = operator !== undefined ? operator(observable) : observable;
    const liftedDispatcher = dispatchOperator !== undefined
        ? dispatchOperator(dispatcher)
        : dispatcher;
    return ix_1.createAsyncIteratorResource(liftedDispatcher, liftedObservable, disposable);
};
exports.lift = (operator) => liftImpl(operator, undefined);
exports.liftReq = (operator) => liftImpl(undefined, operator);
//# sourceMappingURL=index.js.map