import { createAsyncIteratorResource, } from "@reactive-js/ix";
const liftImpl = (operator, dispatchOperator) => iterator => {
    const observable = iterator.observable || iterator;
    const dispatcher = iterator.dispatcher || ((req) => iterator.dispatch(req));
    const disposable = iterator.disposable || iterator;
    const liftedObservable = operator !== undefined ? operator(observable) : observable;
    const liftedDispatcher = dispatchOperator !== undefined
        ? dispatchOperator(dispatcher)
        : dispatcher;
    return createAsyncIteratorResource(liftedDispatcher, liftedObservable, disposable);
};
export const lift = (operator) => liftImpl(operator, undefined);
export const liftReq = (operator) => liftImpl(undefined, operator);
//# sourceMappingURL=index.js.map